/*
    dbus Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "module/mr16.h"
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "bsp/uart.h"
#include <stdint.h>
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
uint8_t txbuffer[127]={0};
/* USER STRUCT BEGIN */
/* 定义消息结构体用于传递txbuffer数据 */

/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_dbus(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / DBUS_FREQ;

  osDelay(DBUS_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */

  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */
    
    /* 从消息队列接收txbuffer数据 */
    osStatus_t status = osMessageQueueGet(task_runtime.msgq.mr16, &txbuffer, NULL, 0);
    
    if (status == osOK && txbuffer[2] > 0) {
      /* 通过UART1发送数据包 */
      BSP_UART_Transmit(BSP_UART_DBUS, txbuffer, 3 + txbuffer[2] + 2, true);
    }

    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}